;
;  Stream viewer (hex) SVHEX.COM
;    syntax: type filename | svhex
;
;    Designed and programmed by Lo Hung Che
;    Copyright (C) BAHCL 2004
;
;  Dedicated to FreeDOS www.freedos.org
;    under the terms and license of GNU GPL version 2
;
org 100h
segment .text
            mov     sp,stackbot+512       ; stack size = 512 bytes
            mov     bx,sp
            mov     cx,4
            shr     bx,cl
            inc     bx
            mov     ax,ds
            add     ax,bx
            mov     [stream],ax           ; seg. address for data

            call    HW_Setting
            call    FileType
            mov     ax,[fhandle]
            push    ax
            call    Get_Data
            cmp     word [ssize],0
            jz      @0001                 ; no data at all

            call    Last_Line             ; find last top file
            call    Get_Scancode
            mov     bx,[fhandle]
            or      bx,bx
            jz      @0001                 ; stream file
            mov     ax,3E00h              ; close file
            int     21h
@0001:
            call    Clear_Screen
            mov     ax,4C00h
            int     21h
;
; Determine input file be stream/regular
FileType
            xor     ax,ax
            mov     si,80h                ; check command tail
            lodsb
            or      al,al
            jz      @0010                 ; stream
            mov     di,si
            add     di,ax
            xchg    ah,al
            stosb
@0011:
            lodsb
            cmp     al,20h
            jz      @0011
            dec     si
            mov     ax,3D00h              ; open file
            mov     dx,si
            int     21h
            jc      @0010
            mov     [fhandle],ax

            push    es
            mov     ax,40h
            mov     es,ax
            mov     dx,[es:0F0h]          ; iaca intra application comm. area
            mov     cx,[es:0F2h]
            mov     ax,[es:0F4h]
            mov     [quitkey],ax
            xor     ax,ax
            mov     [es:0F0h],ax          ; clear iaca
            mov     [es:0F2h],ax
            mov     [es:0F4h],ax
            pop     es
            mov     ax,4200h
            mov     bx,[fhandle]
            int     21h
@0010:
            ret
;
; Display data to screen
Show_Data
            push    bp
            mov     bp,sp
            mov     cx,[bp+6]             ; lines to print
            xor     di,di
@nextline:
            push    cx
            mov     ax,[bp+4]             ; line# to print
            push    ax
            call    Make_String
            inc     word [bp+4]
            push    es
            mov     ax,[vid_seg]
            mov     es,ax
            mov     cx,[linewidth]        ; line size
            mov     si,buffer
            mov     ah,07                 ; color attribute
@nextbyte:
            lodsb
            stosw
            loop    @nextbyte
            pop     es
            pop     cx
            loop    @nextline

            mov     ax,[bp+4]
            pop     bp
            ret     4
;
;
; format a string for display
Make_String
            push    bp
            mov     bp,sp
            push    di
            push    ds

            mov     di,buffer+57
            mov     cx,16                 ; get the offset
            xor     dx,dx
            mov     ax,[bp+4]
            mul     cx
            mov     si,ax
            add     ax,cx
            sub     ax,[ssize]
            jc      @0030
            push    ax
            push    cx
            xor     ax,ax
            rep     stosb
            mov     cx,48
            mov     di,buffer+8
            rep     stosb
            pop     cx
            pop     ax
            sub     ax,cx
            xchg    ax,cx
            neg     cx
            mov     al,'-'
            mov     di,buffer+31
            stosb
@0030:
            mov     di,buffer+57
            push    cx
            mov     ax,[stream]
            mov     ds,ax
            rep     movsb
            pop     cx
            pop     ds
            mov     si,buffer+57
            mov     di,buffer+8
            mov     bx,HexTable
.loop
            push    cx
            lodsb
            mov     ah,al
            mov     cl,4
            shr     al,cl
            xlatb                               ; translate content
            stosb
            xchg    ah,al
            and     al,00001111b
            xlatb
            stosb
            inc     di
            pop     cx
            loop    .loop

            mov     ax,[bp+4]                   ; line #
            xchg    ah,al
            mov     di,buffer+1
            mov     bx,HexTable

            mov     dx,ax
            mov     ah,al
            mov     cl,4
            shr     al,cl
            xlatb                               ; translate line #
            stosb
            xchg    ah,al
            and     al,00001111b
            xlatb
            stosb

            mov     ax,dx
            xchg    ah,al
            mov     ah,al
            mov     cl,4
            shr     al,cl
            xlatb
            stosb
            xchg    ah,al
            and     al,00001111b
            xlatb
            stosb

            pop     di
            pop     bp
            ret     2
;
; get keyboard scancode
Get_Scancode
            call    Clear_Screen
            mov     ax,[totlines]
            cmp     ax,[lineperpage]
            jb      @0020
            mov     ax,[lineperpage]
@0020:
            push    ax
            mov     ax,[linenum]
            push    ax
            call    Show_Data

            xor     ax,ax
            int     16h
            cmp     ax,[quitkey]
            jne     @0021
            ret
@0021:
            mov     cx,[keys]
            inc     cx
            mov     di,scancode
            mov     si,di
            repne   scasw
            jcxz    Get_Scancode
            mov     ax,di
            sub     ax,si
            dec     ax
            dec     ax

            mov     bx,procnames
            add     bx,ax
            call    [bx]

            cmp     ax,1
            jnz     Get_Scancode
            ret
;
; key = escape
K_Esc
            mov     ax,1
            ret
; key = up
K_Up
            mov     ax,1
            mov     dx,1
            call    Check_Limit
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; key = down
K_Dn
            mov     ax,1
            xor     dx,dx
            call    Check_Limit
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; key = page up
K_P_Up
            mov     ax,[lineperpage]
            mov     dx,1
            call    Check_Limit
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; key = page down
K_P_Dn
            mov     ax,[lineperpage]
            xor     dx,dx
            call    Check_Limit
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; key = home
K_Home
            xor     ax,ax
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; key = end
K_End
            mov     ax,[totlines]
            xor     dx,dx
            call    Check_Limit
            mov     [linenum],ax
            xor     ax,ax
            ret
;
; clear the screen, send cursor home
Clear_Screen
            push    es
            mov     ax,[vid_seg]
            mov     es,ax
            xor     di,di

            mov     ax,0720h
            mov     cx,[lineperpage]
.loop       push    cx
            mov     cx,[linewidth]
            rep     stosw
            pop     cx
            loop    .loop
            pop     es
            mov     ah,2                  ; send cursor home
            xor     bx,bx
            xor     dx,dx
            int     10h
            ret
;
;
; get data from stream
Get_Data
            push    bp
            mov     bp,sp
            push    ds
            mov     ax,[stream]
            mov     ds,ax
            mov     ax,3F00h
            xor     dx,dx
            mov     cx,0FFF0h
            mov     bx,[bp+4]             ; file handle
            int     21h
            pop     ds
            mov     [ssize],ax
            mov     bx,16
            xor     dx,dx
            div     bx
            or      dx,dx
            jz      @0090
            inc     ax
@0090:
            mov     [totlines],ax
            pop     bp
            ret     2
;
HW_Setting
            mov     ah,0Fh                ; set up display mode seg. address
            int     10h
            cmp     al,7                  ; mono
            jnz     @0100
            mov     ax,0B000h
            mov     [vid_seg],ax
@0100:
            push    es
            mov     ax,40h
            mov     es,ax
            mov     ax,[es:4Ah]
            mov     [linewidth],ax
            xor     ax,ax
            mov     al,[es:84h]
            inc     ax
            mov     [lineperpage],ax
            pop     es
            ret
;
;  Decide the last line
Last_Line
            mov    ax,[totlines]
            cmp    ax,[lineperpage]
            jna    @0110
            sub    ax,[lineperpage]
            mov    [lastline],ax
@0110:
            ret
;
; Check linenum within limit
Check_Limit
            mov     cx,ax
            xor     ax,ax
            mov     bx,[totlines]
            cmp     bx,[lineperpage]
            jna     @0120                 ; out of range
            or      dx,dx
            jnz     @0123                 ; Up, PageUp
            add     cx,[linenum]          ; Down, PageDown, End
            cmp     cx,[lastline]
            ja      @0121
            mov     ax,cx
            jmp     @0120
@0123:                                    ; for Up, PageUp
            mov     ax,[linenum]
            sub     ax,cx
            jc      @0122
            jmp     @0120
@0122:
            xor     ax,ax
            jmp     @0120
@0121:
            mov     ax,[lastline]
@0120:
            ret
;
;
segment .data
TABSTOP         EQU     8
TAB             EQU     9
CR              EQU     0Dh
LF              EQU     0Ah
fhandle         dw      0
vid_seg         dw      0B800h             ; color
lineperpage     dw      0
linewidth       dw      0
stream          dw      0                  ; stream segment address
ssize           dw      0                  ; stream size
HexTable        dw      '0123456789ABCDEF'
linenum         dw      0                  ; line number
totlines        dw      0
lastline        dw      0                  ; last top line
keys            dw      7
scancode        dw      011Bh,4800h,5000h,4900h,5100h,4700h,4F00h
procnames       dw      K_Esc,K_Up,K_Dn,K_P_Up,K_P_Dn,K_Home,K_End
quitkey         dw      0
buffer          db      '000000  00 00 00 00 00 00 00 00-'
          times 48  db  20h
stackbot
;               db      'Designed and programmed by Lo Hung Che',0
;               db      'Copyright (C) BAHCL 2004',0
;
